/*
 *  BaseFile.h
 *  BaseFunction
 *
 *  Created by pyang on 05-8-2.
 *  Copyright 2005 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef	__BASEFILE__
#define	__BASEFILE__
#pragma once
#pragma export on
#ifdef __cplusplus
extern "C" {
#endif



EXTERN_API(Boolean)	FSRefIsVolume(const FSRef *pFSRef);
EXTERN_API(OSErr)	FSRefGetParentRef(const FSRef *pFSRef,FSRef *parentRef);
EXTERN_API(OSErr)	FSSpecToFSRef(const FSSpec *pSrcSpec,FSRef *pDestRef);
EXTERN_API(OSErr)	FSRefToFSSpec(const FSRef *pFSRef,	FSSpec *pDestSpec);
EXTERN_API(OSErr)	FSGetForkSizes(const FSRef *pFSRef,UInt64 *dateFork,UInt64 *resourceFork);
EXTERN_API(OSErr)	FSGetVRefNum(const FSRef *pFSRef,FSVolumeRefNum *pVRefNum);
EXTERN_API(Boolean)	FSRefIsValid(const FSRef *pFSRef);
EXTERN_API(Boolean)	FSRefIsPackage(const FSRef *pFSRef);
EXTERN_API(OSErr)	FSRefGetDate(const FSRef *pFSRef ,UTCDateTime* pCreatTime,UTCDateTime* pContentModTime,UTCDateTime* pAttrModTime,UTCDateTime* pBackupTime);
EXTERN_API(OSErr)	FSRefIsDirectory(const FSRef *pFSRef, Boolean* bDirectory);
EXTERN_API(OSErr)	FSRefGetName(const FSRef *pFSRef,HFSUniStr255 *outName,TextEncoding *pEncoding);
EXTERN_API(OSErr)	FSRefLock(const FSRef *pFSRef,Boolean bLock);
EXTERN_API(OSErr)	FSRefCheckLock(const FSRef *pFSRef);// err = fLckdErr, or wPrErr( volume locked by hardware),or vLckdErr(volume locked by software)
EXTERN_API(OSErr)	FSRefIsVisiable(const FSRef *pFSRef,Boolean* bVisiable);

enum
{
	kRWXUserAccessMask		= 0x01C0,
	kReadAccessUser			= 0x0100,
	kWriteAccessUser		= 0x0080,
	kExecuteAccessUser		= 0x0040,
	
	kRWXGroupAccessMask		= 0x0038,
	kReadAccessGroup		= 0x0020,
	kWriteAccessGroup		= 0x0010,
	kExecuteAccessGroup		= 0x0008,
	
	kRWXOtherAccessMask		= 0x0007,
	kReadAccessOther		= 0x0004,
	kWriteAccessOther		= 0x0002,
	kExecuteAccessOther		= 0x0001,
	
  	kDropFolderValue    = kWriteAccessOther | kExecuteAccessOther
};
EXTERN_API(OSErr)	FSRefIsWritable(const FSRef *pFSRef,Boolean* bWritable);

typedef Boolean (*EnumFileCallbackPtr)(ItemCount nRefNum, const FSRef* pFSRef, const FSCatalogInfo* pCatalogInfo,void* pParam);// if callback return false, the enumProcess will end 
EXTERN_API(OSErr)	FSEnumDirectoryFile(const FSRef* pFolderRef,FSCatalogInfoBitmap	catalogInfo,EnumFileCallbackPtr pEnumFileProc,void* pParam);

EXTERN_API(OSErr) FSRefDeleteObject(const FSRef* pSource);

typedef	UInt32		CopyAction;
enum {
	kCopyActionStandard,	/* will do the copy with no frills */
	kCopyActionReplace,		/* will delete the existing object and then copy over the new one */
	kCopyActionRename		/* will rename the new object if an object of the same name exists */
};
EXTERN_API(OSErr) FSRefCopyObject(const FSRef* pSource,const FSRef* pDestDir,CopyAction copyAction,
							   const HFSUniStr255* pNewName,FSRef* pOutFSRef,FSSpec* pOutFSSpec);

#ifdef __cplusplus
}
#endif
#pragma export off
#endif //__BASEFILE__