/*
 *  BaseXML.h
 *  BaseFunction
 *
 *  Created by pyang on 05-8-9.
 *  Copyright 2005 __Arcsoft__. All rights reserved.
 *
 */

#ifndef	__BASEXML__
#define	__BASEXML__
#pragma once
#pragma export on
#ifdef __cplusplus
extern "C" {
#endif
	
#define XML_AND			CFSTR("&amp;") // &
#define XML_LESS		CFSTR("&lt;")	// <
#define XML_BIG			CFSTR("&gt;")  // >
#define XML_QUOT		CFSTR("&quot;") //"
#define XML_SINGLEQUOT	CFSTR("&apos;") //'	

EXTERN_API(CFXMLTreeRef)		XMLOpen(const FSRef *pFSRef);
EXTERN_API(Boolean)				XMLSave(CFXMLTreeRef pXMLTree,const FSRef *pFSRef);	
// used for create new XML tree
EXTERN_API(CFXMLTreeRef)		XMLCreateDocTree();

EXTERN_API(CFMutableArrayRef)	XMLGetChildren(CFXMLTreeRef pParentTree,CFStringRef pChildrenName);
EXTERN_API(CFXMLTreeRef)		XMLGetFirstChild(CFXMLTreeRef pParentTree,CFStringRef pChildrenName);

EXTERN_API(CFXMLTreeRef)		XMLAppendElement(CFXMLTreeRef pParentTree,CFStringRef pEleName,CFXMLElementInfo* pElementInfo,Boolean bAsSibling);
EXTERN_API(CFIndex)				XMLGetChildrenCount(CFXMLTreeRef pParentTree);
EXTERN_API(void)				XMLRemoveChild(CFXMLTreeRef pParentTree,CFIndex index);
EXTERN_API(void)				XMLRemoveAllChildren(CFXMLTreeRef pParentTree);
EXTERN_API(CFXMLElementInfo*)	XMLGetElementInfo(CFXMLTreeRef pXMLTree);
EXTERN_API(CFXMLNodeRef)		XMLGetNode(CFXMLTreeRef pXMLTree);
EXTERN_API(CFStringRef)			XMLGetTreeTypeString(CFXMLTreeRef pXMLTree);
EXTERN_API(CFStringRef)			XMLGetTreeContentString(CFXMLTreeRef pXMLTree);
EXTERN_API(CFIndex)				XMLGetChildrenCount(CFXMLTreeRef pXMLTree);
EXTERN_API(CFXMLTreeRef)		XMLGetChildrenAtIndex(CFXMLTreeRef pXMLTree,CFIndex index);
EXTERN_API(void)				XMLRemoveChild(CFXMLTreeRef pXMLTree,CFIndex index);
EXTERN_API(void)				XMLRemoveAllChildren(CFXMLTreeRef pXMLTree);


#ifdef __cplusplus
}
#endif
#pragma export off
#endif //__BASEXML__